import casadi.*

a = [75.0 125.0 100.0];
m = 3;

b = [80.0 65.0 70.0 85.0];
n = 4;

C = [63.0 15.0 32.0 31.0;
    71.0 38.0 60.0 40.0;
    34.0 25.0 17.0 42.0];

X = MX.sym('X', m, n);

f = 0;

for i = 1:m
    
    for j = 1:n
        
        f = f + C(i,j) * X(i,j); 
        
    end 
    
end


g = {};
g_min = [];
g_max = [];


for i = 1:m

    e = 0;

    for j = 1:n

        e = e + X(i,j);
    end
           
    g = {g{:} e};
    g_min = [g_min; a(i)];
    g_max = [g_max; a(i)];

end

for j = 1:n

    e = 0;

    for i = 1:m

        e = e + X(i,j);

    end
        
    g = {g{:} e};
    g_min = [g_min; b(j)];
    g_max = [g_max; b(j)];

end


g = vertcat(g{:});
X = vec(X);

lp = struct('x', X, 'f', f, 'g', g);

solver = nlpsol('solver', 'ipopt', lp);

X_init = zeros(size(X));
X_min = zeros(size(X));
X_max = Inf(size(X));

solution = solver('x0', X_init, 'lbx', X_min, 'ubx', X_max, ...
    'lbg', g_min, 'ubg', g_max);

K_opt = solution.f;
X_opt = reshape(solution.x, 3, 4);

fprintf('\nTransportation cost:\n\n');
disp(full(K_opt));

fprintf('\nTransportation matrix:\n\n');
disp(full(X_opt));
